/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoPleiadesUtilTranslationNotfound2Xliff]のクラス
 */
package blanco.pleiades.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.pleiades.util.task.valueobject.BlancoPleiadesUtilTranslationNotfound2XliffProcessInput;

/**
 * Apache Antタスク [BlancoPleiadesUtilTranslationNotfound2Xliff]のクラス。
 *
 * [XLIFF対応ツール] Pleiades translatoin-notfound 形式から翻訳必要箇所をXLIFF形式に適用します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.pleiades.util.task]にBlancoPleiadesUtilTranslationNotfound2XliffBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancopleiadesutiltranslationnotfound2xliff&quot; classname=&quot;blanco.pleiades.util.task.BlancoPleiadesUtilTranslationNotfound2XliffTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoPleiadesUtilTranslationNotfound2XliffTask extends Task {
    /**
     * [XLIFF対応ツール] Pleiades translatoin-notfound 形式から翻訳必要箇所をXLIFF形式に適用します。
     */
    protected BlancoPleiadesUtilTranslationNotfound2XliffProcessInput fInput = new BlancoPleiadesUtilTranslationNotfound2XliffProcessInput();

    /**
     * [XLIFF対応ツール] Pleiades translatoin-notfound 形式から翻訳必要箇所をXLIFF形式に適用します。
     */
    protected boolean fIsFieldSourcefileProcessed = false;

    /**
     * [XLIFF対応ツール] Pleiades translatoin-notfound 形式から翻訳必要箇所をXLIFF形式に適用します。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力元となるPleiadesの translation-notfound.properties ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcefile(final String arg) {
        fInput.setSourcefile(arg);
        fIsFieldSourcefileProcessed = true;
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力元となるPleiadesの translation-notfound.properties ファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcefile() {
        return fInput.getSourcefile();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となるXLIFFディレクトリ。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となるXLIFFディレクトリ。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoPleiadesUtilTranslationNotfound2XliffTask begin.");

        // 項目番号[1]、アトリビュート[sourcefile]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcefileProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcefile]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcefile:[" + getSourcefile() + "]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoPleiadesUtilTranslationNotfound2XliffProcessインタフェースを実装して blanco.pleiades.util.taskパッケージに BlancoPleiadesUtilTranslationNotfound2XliffProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoPleiadesUtilTranslationNotfound2XliffProcess proc = new BlancoPleiadesUtilTranslationNotfound2XliffProcessImpl();
            if (proc.execute(fInput) != BlancoPleiadesUtilTranslationNotfound2XliffBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
